/**
 * Copyright (c) 2001-2008 U-Mart Project
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * ---------------------------------------------------------------------
 */
package strategy_v2;

import java.util.*;

/**
 * 敨ipړσG[WFgNXłD
 */
public class UMovingAverageAgent extends UAgent {
	
	/** Z̐ߐ̃ftHgl */
	public static final int DEFAULT_SHORT_TERM = 8;
	
	/** ̐ߐ̃ftHgl */
	public static final int DEFAULT_MEDIUM_TERM = 16;
  
  /** ʂ̍ől̃ftHgl */
  public static final int DEFAULT_MAX_QUANT = 50;

  /** ʂ̍ŏl̃ftHgl */
  public static final int DEFAULT_MIN_QUANT = 10;

  /** /|WV̍ől̃ftHgl */
  public static final int DEFAULT_MAX_POSITION = 300;

	/** Z̐ߐ */
	private int fShortTerm = DEFAULT_SHORT_TERM;
	
	/** ̐ߐ */
	private int fMediumTerm = DEFAULT_MEDIUM_TERM;

  /** ʂ̍ől */
  private int fMaxQuant = DEFAULT_MAX_QUANT;

  /** ʂ̍ŏl */
  private int fMinQuant = DEFAULT_MIN_QUANT;

  /** /|WV̍ől */
  private int fMaxPosition = DEFAULT_MAX_POSITION;
  
  /** Z̐ߐ̃vpeB(ShortTerm) */
  public static final String SHORT_TERM_KEY = "ShortTerm";

  /** ̐ߐ̃vpeB(MediumTerm) */
  public static final String MEDIUM_TERM_KEY = "MediumTerm";
  
  /** ʂ̍ől̃vpeB(MaxQuant) */
	public static final String MAX_QUANT_KEY = "MaxQuant";

	/** ʂ̍ŏl̃vpeB(MinQuant) */
	public static final String MIN_QUANT_KEY = "MinQuant";
	
	/** /|WV̍ől̃vpeB(MaxPosition) */
	public static final String MAX_POSITION_KEY = "MaxPosition";
  
  /** 1ߑOɂZړϒl */
	private double fPreviousShortTermMovingAverage = UOrderForm.INVALID_PRICE;
	
	/** 1ߑOɂ钆ړϒl */
	private double fPreviousMediumTermMovingAverage = UOrderForm.INVALID_PRICE;

  /**
   * RXgN^łD
   * @param loginName OC
   * @param passwd pX[h
   * @param realName 
   * @param seed ̎
   */
	public UMovingAverageAgent(String loginName, String passwd, String realName, int seed) {
		super(loginName, passwd, realName, seed);
	}

	/**
	 * Z̐ߐԂ܂D
	 * @return Z̐ߐ
	 */
	public int getShortTerm() {
		return fShortTerm;
	}
	
	/**
	 * ̐ߐԂ܂D
	 * @return ̐ߐ
	 */
	public int getMediumTerm() {
		return fMediumTerm;
	}

	/**
	 * ŏʂԂ܂D
	 * @return ŏ
	 */
	public int getMinQuant() {
		return fMinQuant;
	}

	/**
	 * ő咍ʂԂ܂D
	 * @return ő咍
	 */
	public int getMaxQuant() {
		return fMaxQuant;
	}

	/**
	 * ő|WVԂ܂D
	 * @return ő|WV
	 */
	public int getMaxPosition() {
		return fMaxPosition;
	}

  /**
   * [쐬܂D
   * ftHgł́uȂv[ԂȂ̂ŁCqNXŕKI[o[ChĂD
   * @param day 
   * @param session 
   * @param maxDays 
   * @param noOfSessionsPerDay 1̐ߐ
   * @param spotPrices inDspotPrices[0]spotPrices[119]܂ł120ߕ̃f[^i[Ă܂DspotPrices[119]߂̉iłDCiĂȂꍇC-1Ă̂ŒӂĂD
   * @param futuresPrices inDspotPrices[0]spotPrices[119]܂ł120ߕ̃f[^i[Ă܂DspotPrices[119]߂̉iłDCiĂȂꍇC-1Ă̂ŒӂĂD܂CJn߂O͌ii[Ă܂D
   * @param position |WVDȂΔz(OE|WV)CȂΔziV[gE|WVj\܂D
   * @param money cD^longł邱ƂɒӁD
   * @return UOrderForm[] [̔z 
   */
  public UOrderForm[] makeOrderForms(int day, int session, 
                                      int maxDays, int noOfSessionsPerDay, 
                                      int[] spotPrices, int[] futuresPrices, 
                                      int position, long money) {
  	Random rand = getRandom();
  	UOrderForm[] forms = new UOrderForm[1];
  	forms[0] = new UOrderForm();
  	int[] prices = futuresPrices;
    forms[0].setBuySell(chooseAction(prices));
    println("");
    print("day=" + day + ", session=" + session
          + ", futures=" + prices[prices.length - 1] 
          + ", shortTerm=" + fPreviousShortTermMovingAverage
          + ", mediumTerm=" + fPreviousMediumTermMovingAverage);
    if (forms[0].getBuySell() == UOrderForm.NONE) {
    	return forms;
    }
    if (forms[0].getBuySell() == UOrderForm.BUY) {
      if (position > fMaxPosition) {
        forms[0].setBuySell(UOrderForm.NONE);
        return forms;
      }
    } else if (forms[0].getBuySell() == UOrderForm.SELL) {
      if (position < -fMaxPosition) {
        forms[0].setBuySell(UOrderForm.NONE);
        return forms;
      }
    }
    forms[0].setPrice(determinePrice(forms[0].getBuySell(), prices));
    forms[0].setQuantity(fMinQuant + rand.nextInt(fMaxQuant - fMinQuant + 1));
    print(" => " + forms[0].getBuySellByString() + ", price=" + forms[0].getPrice()
           + ", quantity=" + forms[0].getQuantity()); 
    return forms;
  }
  
  /**
   * i肵ĕԂ܂D
   * @param action 敪
   * @param prices inDCprices[prices.length]𒼋߂ƂĂD
   * @return i
   */
  private int determinePrice(int action, int[] prices) {
  	int price = UOrderForm.INVALID_PRICE;
  	int widthOfPrice = Math.abs(prices[prices.length - 1] - prices[prices.length - 2]);
  	if (action == UOrderForm.BUY) {
      price = prices[prices.length - 1] + widthOfPrice + (int)((double)widthOfPrice / 4.0 * getRandom().nextGaussian());
    } else if (action == UOrderForm.SELL) {
      price = prices[prices.length - 1] - widthOfPrice + (int)((double)widthOfPrice / 4.0 * getRandom().nextGaussian());
    }
  	if (price < 0) {
  		price = 1;
  	}
  	return price;
  }
  
  /**
   * 敪IŕԂ܂D
   * @param prices inDCprices[prices.length]𒼋߂ƂĂD
   * @return 敪
   */
  private int chooseAction(int[] prices) {
  	int action = UOrderForm.NONE;
  	double shortTermMovingAverage = calculateMovingAverage(prices, fShortTerm);
  	double mediumTermMovingAverage = calculateMovingAverage(prices, fMediumTerm);
  	if (fPreviousShortTermMovingAverage != UOrderForm.INVALID_PRICE
  			&& fPreviousMediumTermMovingAverage != UOrderForm.INVALID_PRICE
  			&& shortTermMovingAverage != UOrderForm.INVALID_PRICE
  			&& mediumTermMovingAverage != UOrderForm.INVALID_PRICE) {
  		if (fPreviousShortTermMovingAverage < fPreviousMediumTermMovingAverage
  				&& mediumTermMovingAverage < shortTermMovingAverage) {
  			action = UOrderForm.BUY;
  		} else if (fPreviousMediumTermMovingAverage < fPreviousShortTermMovingAverage
  				        && shortTermMovingAverage < mediumTermMovingAverage) {
  			action = UOrderForm.SELL;
  		}
  	}
  	fPreviousShortTermMovingAverage = shortTermMovingAverage;
  	fPreviousMediumTermMovingAverage = mediumTermMovingAverage;
  	return action;
  }
  
  /**
   * ߂termߕ̉in̈ړϒlvZĕԂ܂D
   * CiĂȂꍇ́CUOrderForm.INVALID_PRICE (=-1)Ԃ܂D
   * @param prices inDCprices[prices.length - 1]𒼋߂ƂĂD
   * @param term ړςƂ
   * @return ߂termߕ̉in̈ړϒl
   */
  private double calculateMovingAverage(int[] prices, int term) {
  	double sum = 0.0;
  	for (int i = 0; i < term; ++i) {
  		if (prices[prices.length - 1 - i] < 0) {
  			return (double)UOrderForm.INVALID_PRICE;
  		}
  		sum += (double)prices[prices.length - 1 - i];
  	}
  	return sum / (double)term;
  }

  /**
   * G[WFg̃VXep[^ݒ肵܂D
   * @param args VXep[^
   */
  public void setParameters(String[] args) {
    super.setParameters(args);
    for (int i = 0; i < args.length; ++i) {
      StringTokenizer st = new StringTokenizer(args[i], "= ");
      String key = st.nextToken();
      String value = st.nextToken();
      if (key.equals(UMovingAverageAgent.SHORT_TERM_KEY)) {
        fShortTerm = Integer.parseInt(value);
        println("ShortTerm has been changed to " + fShortTerm);
      } else if (key.equals(UMovingAverageAgent.MEDIUM_TERM_KEY)) {
      	fMediumTerm = Integer.parseInt(value);
      	println("MediumTerm has been changed to " + fMediumTerm);
      } else if (key.equals(UMovingAverageAgent.MIN_QUANT_KEY)) {
        fMinQuant = Integer.parseInt(value);
        println("MinQuant has been changed to " + fMinQuant);
      } else if (key.equals(UMovingAverageAgent.MAX_QUANT_KEY)) {
        fMaxQuant = Integer.parseInt(value);
        println("MaxQuant has been changed to " + fMaxQuant);
      } else if (key.equals(UMovingAverageAgent.MAX_POSITION_KEY)) {
        fMaxPosition = Integer.parseInt(value);
        println("MaxPosition has been changed to " + fMaxPosition);
      } else {
      	println("Unknown parameter:" + key + " in RandomStrategy.setParameters");
      }
    }
  }
}
