/**
 * Copyright (c) 2001-2008 U-Mart Project
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * ---------------------------------------------------------------------
 */
package strategy_v2;

import java.util.*;

/**
 * 敨ip郉_G[WFgNXłD
 */
public class URandomAgent extends UAgent {
	
  /** ĩ̕ftHgl */
  public static final int DEFAULT_WIDTH_OF_PRICE = 20;

  /** ʂ̍ől̃ftHgl */
  public static final int DEFAULT_MAX_QUANT = 50;

  /** ʂ̍ŏl̃ftHgl */
  public static final int DEFAULT_MIN_QUANT = 10;

  /** /|WV̍ől̃ftHgl */
  public static final int DEFAULT_MAX_POSITION = 300;

  /** ߂̉iȂƂɗp鉿ĩftHgl */
  public static final int DEFAULT_NOMINAL_PRICE = 3000;

  /** i̕ */
  private int fWidthOfPrice = DEFAULT_WIDTH_OF_PRICE;

  /** ʂ̍ől */
  private int fMaxQuant = DEFAULT_MAX_QUANT;

  /** ʂ̍ŏl */
  private int fMinQuant = DEFAULT_MIN_QUANT;

  /** /|WV̍ől */
  private int fMaxPosition = DEFAULT_MAX_POSITION;

  /** ߂̉iȂƂɗp鉿i */
  private int fNominalPrice = DEFAULT_NOMINAL_PRICE;

	/** ĩvpeB(WidthOfPrice) */
	public static final String WIDTH_OF_PRICE_KEY = "WidthOfPrice";

	/** ʂ̍ől̃vpeB(MaxQuant) */
	public static final String MAX_QUANT_KEY = "MaxQuant";

	/** ʂ̍ŏl̃vpeB(MinQuant) */
	public static final String MIN_QUANT_KEY = "MinQuant";
	
	/** /|WV̍ől̃vpeB(MaxPosition) */
	public static final String MAX_POSITION_KEY = "MaxPosition";
	
	/** ߂̉iȂƂɗp鉿ĩvpeB(NominalPrice) */
	public static final String NOMINAL_PRICE_KEY = "NominalPrice";
  
  /**
   * RXgN^łD
   * @param loginName OC
   * @param passwd pX[h
   * @param realName 
   * @param seed ̎
   */
	public URandomAgent(String loginName, String passwd, String realName, int seed) {
		super(loginName, passwd, realName, seed);
	}

	/**
	 * iԂ܂D
	 * @return i
	 */
	public int getWidthOfPrice() {
		return fWidthOfPrice;
	}

	/**
	 * ŏʂԂ܂D
	 * @return ŏ
	 */
	public int getMinQuant() {
		return fMinQuant;
	}

	/**
	 * ő咍ʂԂ܂D
	 * @return ő咍
	 */
	public int getMaxQuant() {
		return fMaxQuant;
	}

	/**
	 * ő|WVԂ܂D
	 * @return ő|WV
	 */
	public int getMaxPosition() {
		return fMaxPosition;
	}

	/**
	 * sꉿîƂ̒iԂ܂D
	 * @return sꉿîƂ̒i
	 */
	public int getNominalPrice() {
		return fNominalPrice;
	}


  /**
   * [쐬܂D
   * ftHgł́uȂv[ԂȂ̂ŁCqNXŕKI[o[ChĂD
   * @param day 
   * @param session 
   * @param maxDays 
   * @param noOfSessionsPerDay 1̐ߐ
   * @param spotPrices inDspotPrices[0]spotPrices[119]܂ł120ߕ̃f[^i[ĂDspotPrices[119]߂̉iłDCiĂȂꍇC-1Ă̂ŒӂĂD
   * @param futurePrices inDspotPrices[0]spotPrices[119]܂ł120ߕ̃f[^i[Ă܂DspotPrices[119]߂̉iłDCiĂȂꍇC-1Ă̂ŒӂĂD܂CJn߂O͌ii[Ă܂D
   * @param position |WVDȂΔz(OE|WV)CȂΔziV[gE|WVj\܂D
   * @param money cD^longł邱ƂɒӂĂD
   * @return UOrderForm[] [̔z 
   */
	public UOrderForm[] makeOrderForms(int day, int session, 
                                      int maxDays, int noOfSessionsPerDay, 
                                      int[] spotPrices, int[] futurePrices, 
                                      int position, long money) {
  	Random rand = getRandom();
  	UOrderForm[] forms = new UOrderForm[1];
  	forms[0] = new UOrderForm();
    forms[0].setBuySell(rand.nextInt(2) + 1);
    if (forms[0].getBuySell() == UOrderForm.BUY) {
      if (position > fMaxPosition) {
        forms[0].setBuySell(UOrderForm.NONE);
        return forms;
      }
    } else if (forms[0].getBuySell() == UOrderForm.SELL) {
      if (position < -fMaxPosition) {
        forms[0].setBuySell(UOrderForm.NONE);
        return forms;
      }
    }
    int latestPrice = getLatestPrice(futurePrices);
    if (latestPrice == UOrderForm.INVALID_PRICE) {
      latestPrice = getLatestPrice(spotPrices);
    }
    if (latestPrice == UOrderForm.INVALID_PRICE) {
      latestPrice = fNominalPrice;
    }
    int price = latestPrice + (int)((double)fWidthOfPrice * rand.nextGaussian());
    if (price <= 0) {
    	price = 1;
    }
    forms[0].setPrice(price);
    forms[0].setQuantity(fMinQuant + rand.nextInt(fMaxQuant - fMinQuant + 1));
    println("day=" + day + ", session=" + session + ", latestPrice="  + latestPrice
    		    + ", " + forms[0].getBuySellByString() + ", price=" + forms[0].getPrice()
            + ", quantity=" + forms[0].getQuantity());
    return forms;
  }

  /**
   * G[WFg̃VXep[^ݒ肵܂D
   * @param args VXep[^
   */
  public void setParameters(String[] args) {
    super.setParameters(args);
    for (int i = 0; i < args.length; ++i) {
      StringTokenizer st = new StringTokenizer(args[i], "= ");
      String key = st.nextToken();
      String value = st.nextToken();
      if (key.equals(URandomAgent.WIDTH_OF_PRICE_KEY)) {
        fWidthOfPrice = Integer.parseInt(value);
        println("WidthOfPrice has been changed to " + fWidthOfPrice);
      } else if (key.equals(URandomAgent.MIN_QUANT_KEY)) {
        fMinQuant = Integer.parseInt(value);
        println("MinQuant has been changed to " + fMinQuant);
      } else if (key.equals(URandomAgent.MAX_QUANT_KEY)) {
        fMaxQuant = Integer.parseInt(value);
        println("MaxQuant has been changed to " + fMaxQuant);
      } else if (key.equals(URandomAgent.MAX_POSITION_KEY)) {
        fMaxPosition = Integer.parseInt(value);
        println("MaxPosition has been changed to " + fMaxPosition);
      } else if (key.equals(URandomAgent.NOMINAL_PRICE_KEY)) {
      	fNominalPrice = Integer.parseInt(value);
      	println("NominalPrice has been changed to " + fNominalPrice);      	
      } else {
      	println("Unknown parameter:" + key + " in RandomStrategy.setParameters");
      }
    }
  }
}
